import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';

import 'hi_teacher_screenshot_listener_platform_interface.dart';

/// An implementation of [HiTeacherScreenshotListenerPlatform] that uses method channels.
class MethodChannelHiTeacherScreenshotListener extends HiTeacherScreenshotListenerPlatform {
  static const methodChannelName = 'dev.hiteacher.screenshot_listener/bridge';
  static const screenshotChannelName = 'dev.hiteacher.screenshot_listener/listener';

  @visibleForTesting
  static const methodChannel = MethodChannel(methodChannelName);

  static const screenshotChannel = EventChannel(screenshotChannelName);

  @override
  Future<String?> getPlatformVersion() async {
    final version = await methodChannel.invokeMethod<String>('getPlatformVersion');
    return version;
  }

  @override
  Future<Map<String, Object>> startListen() async {
    final result = await methodChannel.invokeMethod('start');
    Map<String, Object> obj = {
      "success" : result["success"],
      "message" : result["message"],
    };
    return obj;
  }

  @override
  Stream<String?> getUserScreenshot() {
    return screenshotChannel.receiveBroadcastStream().map((event) => event);
  }
}
