import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'hi_teacher_screenshot_listener_method_channel.dart';

abstract class HiTeacherScreenshotListenerPlatform extends PlatformInterface {
  /// Constructs a HiTeacherScreenshotListenerPlatform.
  HiTeacherScreenshotListenerPlatform() : super(token: _token);

  static final Object _token = Object();

  static HiTeacherScreenshotListenerPlatform _instance = MethodChannelHiTeacherScreenshotListener();

  /// The default instance of [HiTeacherScreenshotListenerPlatform] to use.
  ///
  /// Defaults to [MethodChannelHiTeacherScreenshotListener].
  static HiTeacherScreenshotListenerPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [HiTeacherScreenshotListenerPlatform] when
  /// they register themselves.
  static set instance(HiTeacherScreenshotListenerPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  Future<Map> startListen() {
    throw UnimplementedError('startScreenshotListener() has not been implemented.');
  }

  Stream<String?> getUserScreenshot() {
    throw UnimplementedError('userScreenshot() has not been implemented.');
  }
}
