import 'package:flutter_test/flutter_test.dart';
import 'package:hi_teacher_screenshot_listener/hi_teacher_screenshot_listener.dart';
import 'package:hi_teacher_screenshot_listener/hi_teacher_screenshot_listener_platform_interface.dart';
import 'package:hi_teacher_screenshot_listener/hi_teacher_screenshot_listener_method_channel.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

class MockHiTeacherScreenshotListenerPlatform
    with MockPlatformInterfaceMixin
    implements HiTeacherScreenshotListenerPlatform {

  @override
  Future<String?> getPlatformVersion() => Future.value('42');

  @override
  Stream<String?> getUserScreenshot() {
    // TODO: implement getUserScreenshot
    throw UnimplementedError();
  }

  @override
  Future<Map> startListen() {
    // TODO: implement startListen
    throw UnimplementedError();
  }
}

void main() {
  final HiTeacherScreenshotListenerPlatform initialPlatform = HiTeacherScreenshotListenerPlatform.instance;

  test('$MethodChannelHiTeacherScreenshotListener is the default instance', () {
    expect(initialPlatform, isInstanceOf<MethodChannelHiTeacherScreenshotListener>());
  });

  test('getPlatformVersion', () async {
    HiTeacherScreenshotListener hiTeacherScreenshotListenerPlugin = HiTeacherScreenshotListener();
    MockHiTeacherScreenshotListenerPlatform fakePlatform = MockHiTeacherScreenshotListenerPlatform();
    HiTeacherScreenshotListenerPlatform.instance = fakePlatform;

    expect(await hiTeacherScreenshotListenerPlugin.getPlatformVersion(), '42');
  });
}
